## Summary

Briefly describe the changes and the goal of this PR. Make sure the PR title summarizes the changes effectively.

## Changes

List the major and minor changes.

- Major Changes
  - ...
- Minor Changes
  - ...

## Motivation

Why are these changes necessary? How do they improve the cookbook?

## Self Review Checklist

- [ ] Is the writing easily skimmable?
  - Sections have informative titles.
  - Key takeaways are upfront.
  - Short paragraphs and topic sentences are used.
- [ ] Is the writing quality high?
  - Sentences are simple and unambiguous.
  - Demonstrative pronouns are avoided or clearly referenced.
  - No left-branching sentences.
- [ ] Is the content universally helpful?
  - Terminology is specific and avoids jargon.
  - Provides solutions to common problems.
  - Code examples are general and exportable.
- [ ] Is the content consistent?
  - Styling and formatting align with existing documentation.
  - Consistent use of punctuation and case.

**Note:** For additional guidelines on writing good documentation, check out [What Makes Documentation Good](https://cookbook.openai.com/what_makes_documentation_good).
